package de.oaa.xxx.games.common.entity;

import de.oaa.xxx.games.bdsm.GeschlechtEnum;
import de.oaa.xxx.games.common.aufgaben.Finisher;
import de.oaa.xxx.games.common.aufgaben.Werkzeug;
import jakarta.persistence.CascadeType;
import jakarta.persistence.CollectionTable;
import jakarta.persistence.Column;
import jakarta.persistence.ElementCollection;
import jakarta.persistence.Entity;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;
import jakarta.persistence.Id;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.JoinTable;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

@Getter
@Setter
@Entity
@Table(name = "finisher")
public class FinisherEntity {

    @Id
    @Column
    private UUID finisherId;
    @Column
    private String kurzText;
    @Column(columnDefinition = "TEXT")
    private String text;
    @Enumerated(EnumType.STRING)
    @Column
    private GeschlechtEnum geschlecht;
    @ManyToOne
    @JoinColumn(name = "gruppeId")
    private AufgabenGruppeEntity aufgabenGruppe;
    @Enumerated(EnumType.STRING)
    @ElementCollection(targetClass = Werkzeug.class)
    @CollectionTable(name = "finisher_benoetigtAktiv", joinColumns = @JoinColumn(name = "finisherId"))
    @Column(name = "werkzeug")
    private List<Werkzeug> benoetigtAktiv;
    @Enumerated(EnumType.STRING)
    @ElementCollection(targetClass = Werkzeug.class)
    @CollectionTable(name = "finisher_benoetigtPassiv", joinColumns = @JoinColumn(name = "finisherId"))
    @Column(name = "werkzeug")
    private List<Werkzeug> benoetigtPassiv;
    @ManyToMany(cascade = CascadeType.DETACH)
    @JoinTable(name = "finisherToy", joinColumns = {@JoinColumn(name = "finisherId")}, inverseJoinColumns = {@JoinColumn(name = "toyId")})
    private List<ToyEntity> benoetigteToys;

    @Override
    public String toString() {
        return "FinisherEntity[id=" + finisherId + ", kurzText=" + kurzText + ", geschlecht=" + geschlecht + "]";
    }

    public Finisher toFinisher() {
        Finisher finisher = new Finisher();
        finisher.setFinisherId(finisherId);
        finisher.setKurzText(kurzText);
        finisher.setText(text);
        finisher.setGeschlecht(geschlecht);
        finisher.setBenoetigtAktiv(benoetigtAktiv != null ? new ArrayList<>(benoetigtAktiv) : new ArrayList<>());
        finisher.setBenoetigtPassiv(benoetigtPassiv != null ? new ArrayList<>(benoetigtPassiv) : new ArrayList<>());
        finisher.setBenoetigteToys(benoetigteToys != null ? benoetigteToys.stream().map(ToyEntity::toToy).toList() : new ArrayList<>());
        finisher.setGruppeId(aufgabenGruppe.getGruppenId());
        return finisher;
    }

    public static FinisherEntity create(Finisher finisher, AufgabenGruppeEntity aufgabenGruppeEntity, List<ToyEntity> toys) {
        FinisherEntity entity = new FinisherEntity();
        entity.setFinisherId(UUID.randomUUID());
        entity.setAufgabenGruppe(aufgabenGruppeEntity);
        entity.setKurzText(finisher.getKurzText());
        entity.setText(finisher.getText());
        entity.setGeschlecht(finisher.getGeschlecht());
        entity.setBenoetigtAktiv(finisher.getBenoetigtAktiv());
        entity.setBenoetigtPassiv(finisher.getBenoetigtPassiv());
        entity.setBenoetigteToys(toys != null ? toys : new ArrayList<>());
        return entity;
    }
}
